'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

PUB main(argc, argv) | buffer, infile, outfile, line, char
   buffer := c.malloc(100)
  ifnot buffer
    c.printf0(string("Could not malloc buffer\n"))

  if (argc <> 2)
    c.printf0(string("usage: man application\n"))
    return
  else
    c.strcpy(buffer, string("/manpages/"))
    c.strcat(buffer, long[argv][1])
    c.strcat(buffer, string(".txt"))
    infile := c.fopen(buffer, string("r"))
    if (infile == 0)
      c.printf1(string("No manual entry for %s\n"), long[argv][1])
      c.free(buffer)
      return

  outfile := c.getstdout

  line := 0
  repeat while c.fgets(buffer, 100, infile)
    c.fputs(buffer, outfile)
    if ++line => 23
      c.printf0(string("<more>"))
      char := c.getchar
      c.printf0(string("\b\b\b\b\b\b      \b\b\b\b\b\b"))
      if char == "q" OR char == 3
        quit
      elseif char == 13
        line--
      else
        line := 0

  c.fclose(infile)
  c.free(buffer)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
