'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib_os"

PUB main(argc, argv) | i, infile, value
  i := 1
  repeat
    if (argc < 2 OR c.strcmp(long[argv][i], string("-")) == 0)
      infile := c.getstdin
    else
      infile := c.fopen(long[argv][i], string("r"))
      if (infile == 0)
        c.printf1(string("Error opening %s\n"), long[argv][i])
        c.exit(1)
      if c.getmod(long[argv][i]) & $10 ' Check if it's a directory
        c.printf1(string("%s is a directory\n"), long[argv][i])
        c.exit(2)
    repeat while ((value := c.fgetc(infile)) => 0)
      if (value == 0)
        c.printf0(string("\n"))
      elseif (value == 4)
        quit
      else
        c.printf1(string("%c"), value)
    if (infile <> c.getstdin)
      c.fclose(infile)
    i++
  while (i < argc)
{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
